//+------------------------------------------------------------------+
//|                                        Chart Separate Window.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_separate_window
//--- input parameters
input ENUM_TIMEFRAMES TimeFrame=PERIOD_CURRENT;
input bool  ShowDateScale=true;   
input bool  ShowPriceScale=true;
//---
#include <Charts\Chart.mqh>
CChart cht;
#include <ChartObjects\ChartObjectSubChart.mqh>
CChartObjectSubChart subCht;
//---
long chartID;
int chartWin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   chartID=ChartID();
   chartWin=ChartWindowFind();
   cht.Attach(chartID);
   subCht.Create(chartID,"SubChart",chartWin,0,0,cht.WidthInPixels(),cht.HeightInPixels(chartWin));
   subCht.Symbol(_Symbol);
   subCht.Period(TimeFrame);
   subCht.Scale(cht.Scale());
   subCht.DateScale(ShowDateScale);
   subCht.PriceScale(ShowPriceScale);
   cht.Redraw();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   cht.Detach();
   subCht.Detach();
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   if(id==CHARTEVENT_CHART_CHANGE)
     {
      subCht.X_Size(cht.WidthInPixels());
      subCht.Y_Size(cht.HeightInPixels(chartWin));
      subCht.Scale(cht.Scale());
      cht.Redraw();
     }
  }
//+------------------------------------------------------------------+
